



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【linux】free命令中cached和buffers的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【linux】free命令中cached和buffers的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 02:44:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>一、命令</h3>
<div>
<pre class="prettyprint linenums">[root@localhost ~]# free -m<br />
             total       used       free     shared    buffers     cached<br />
Mem:          7869       7651        218          1        191       5081<br />
-/+ buffers/cache:       2378       5490<br />
Swap:          478        139        339
</pre>
</div>
<h3>二、计算</h3>
<p>这里使用1、2 分别代表第一行和第二行的数据</p>
<div>
<pre class="prettyprint linenums">total1：表示物理 内存总量<br />
used1：表示总计分配给缓存（包含buffers 与cache ）使用的数量，但其中可能部分缓存并未实际使用<br />
free1：未被分配的内存<br />
shared1：共享内存，一般系统不会用到，这里也不讨论<br />
buffers1： 系统分配但未被使用的buffers 数量<br />
cached1：系统分配但未被使用的cache 数量<br />
used2：实际使用的buffers 与cache 总量，也是实际使用的内存总量<br />
free2：未被 使用的buffers 与cache 和未被分配的内存之和，这就是系统当前实际可用内存</pre>
</div>
<p>可以整理出如下等式</p>
<div>
<pre class="prettyprint linenums">total1 = used1 + free1<br />
total1 = used2 + free2<br />
used1 = buffers1 + cached1 + used2<br />
free2 = buffers1 + cached1 + free1</pre>
</div>
<p>具体计算</p>
<div>
<pre class="prettyprint linenums">7869 = 7651 + 218<br />
7869 = 2378 + 5490  #7868基本相等，因为有shared)<br />
7651 = 191 + 5081 + 2378 #7650 基本相等，因为有shared)<br />
5490 = 191 + 5081 + 218
</pre>
</div>
<p>为什么这样计算呢，因为buffers和cache其实也是内存的一部分，这部分特殊的内存是可以回收的，甚至如果需要我们还可以将这部分buffers和cache给释放出来</p>
<h4>三、区别</h4>
<h4><strong>1、page cahe和buffer cache</strong></h4>
<p>Page cache实际上是针对文件系统的，是文件的缓存，在文件层面上的数据会缓存到page cache。文件的逻辑层需要映射到实际的物理磁盘，这种映射关系由文件系统来完成。当page cache的数据需要刷新时，page cache中的数据交给buffer cache，但是这种处理在2.6版本的内核之后就变的很简单了，没有真正意义上的cache操作。</p>
<p>Buffer cache是针对磁盘块的缓存，也就是在没有文件系统的情况下，直接对磁盘进行操作的数据会缓存到buffer cache中，例如，文件系统的元数据都会缓存到buffer cache中。&nbsp;<br />简单说来，page cache用来缓存文件数据，buffer cache用来缓存磁盘数据。在有文件系统的情况下，对文件操作，那么数据会缓存到page cache，如果直接采用dd等工具对磁盘进行读写，那么数据会缓存到buffer cache。</p>
<p>补充一点，在文件系统层每个设备都会分配一个def_blk_ops的文件操作方法，这是设备的操作方法，在每个设备的inode下面会存在一个radix tree，这个radix tree下面将会放置缓存数据的page页。这个page的数量将会在top程序的buffer一栏中显示。如果设备做了文件系统，那么会生成一个inode，这个inode会分配ext3_ops之类的操作方法，这些方法是文件系统的方法，在这个inode下面同样存在一个radix tree，这里会缓存文件的page页，缓存页的数量在top程序的cache一栏进行统计。从上面的分析可以看出，2.6内核中的buffer cache和page cache在处理上是保持一致的，但是存在概念上的差别，page cache针对文件的cache，buffer是针对磁盘块数据的cache，仅此而已。</p>
<h4>2、cache 和 buffer的区别</h4>
<p>A buffer is something that has yet to be &ldquo;written&rdquo; to disk. A cache is something that has been &ldquo;read&rdquo; from the disk and stored for later use ; 对于共享内存（Shared memory），主要用于在UNIX 环境下不同进程之间共享数据，是进程间通信的一种方法，一般的应用程序不会申请使用共享内存</p>
<p>Cache：高速缓存，是位于CPU与主内存间的一种容量较小但速度很高的存储器。由于CPU的速度远高于主内存，CPU直接从内存中存取数据要等待一定时间周期，Cache中保存着CPU刚用过或循环使用的一部分数据，当CPU再次使用该部分数据时可从Cache中直接调用，这样就减少了CPU的等待时间，提高了系统的效率。Cache又分为一级Cache（L1 Cache）和二级Cache（L2 Cache），L1 Cache集成在CPU内部，L2 Cache早期一般是焊在主板上，现在也都集成在CPU内部，常见的容量有256KB或512KB L2 Cache</p>
<p>它是根据程序的局部性原理而设计的，就是cpu执行的指令和访问的数据往往在集中的某一块，所以把这块内容放入cache后，cpu就不用在访问内存了，这就提高了访问速度。当然若cache中没有cpu所需要的内容，还是要访问内存的</p>
<p><strong>查看CPU的 L1、L2、L3</strong></p>
<div>
<pre class="prettyprint linenums">[root@AY1301180424258d59678 ~]# ll /sys/devices/system/cpu/cpu0/cache/<br />
total 0<br />
drwxr-xr-x 2 root root 0 Jan 26 22:49 index0 #一级cache中的data和instruction cache<br />
drwxr-xr-x 2 root root 0 Jan 26 22:49 index1 #一级cache中的data和instruction cache<br />
drwxr-xr-x 2 root root 0 Jan 26 22:49 index2 #二级cache，共享的<br />
drwxr-xr-x 2 root root 0 Jan 26 22:49 index3 #三级cache，共享的&nbsp;</pre>
</div>
<p>Buffer：缓冲区，一个用于存储速度不同步的设备或优先级不同的设备之间传输数据的区域。通过缓冲区，可以使进程之间的相互等待变少，从而使从速度慢的设备读入数据时，速度快的设备的操作进程不发生间断。</p>
<h4>3、Free中的buffer和cache （它们都是占用内存）基于内存的<strong><br /></strong></h4>
<p>buffer ：作为buffer cache的内存，是块设备的读写缓冲区</p>
<p>cache：作为page cache的内存， 文件系统的cache</p>
<p>如果 cache 的值很大，说明cache住的文件数很多。如果频繁访问到的文件都能被cache住，那么磁盘的读IO 必会非常小</p>
<p><strong>如何释放Cache Memory</strong></p>
<div>
<pre class="prettyprint linenums">To free pagecache:<br />
echo 1 &gt; /proc/sys/vm/drop_caches<br />
To free dentries and inodes:<br />
echo 2 &gt; /proc/sys/vm/drop_caches<br />
To free pagecache, dentries and inodes:<br />
echo 3 &gt; /proc/sys/vm/drop_caches

#注意，释放前最好sync一下，防止丢失数据，但是一般情况下没有必要手动释放内存</pre>
</div>
<h4>4、总结</h4>
<h4>cached是cpu与内存间的，buffer是内存与磁盘间的，都是为了解决速度不对等的问题</h4>
<ul><li><p>缓存（cached）是把读取过的数据保存起来，重新读取时若命中（找到需要的数据）就不要去读硬盘了，若没有命中就读硬盘。其中的数据会根据读取频率进行组织，把最频繁读取的内容放在最容易找到的位置，把不再读的内容不断往后排，直至从中删除</p></li>
<li><p>缓冲（buffers）是根据磁盘的读写设计的，把分散的写操作集中进行，减少磁盘碎片和硬盘的反复寻道，从而提高系统性能。linux有一个守护进程定期 清空缓冲内容（即写入磁盘），也可以通过sync命令手动清空缓冲。举个例子吧：我这里有一个ext2的U盘，我往里面cp一个3M的MP3，但U盘的灯 没有跳动，过了一会儿（或者手动输入sync）U盘的灯就跳动起来了。卸载设备时会清空缓冲，所以有些时候卸载一个设备时要等上几秒钟</p></li>
<li><p>修改/etc/sysctl.conf中的vm.swappiness右边的数字可以在下次开机时调节swap使用策略。该数字范围是0～100，数字越大越倾向于使用swap。默认为60，可以改一下试试。&ndash;两者都是RAM中的数据</p></li></ul>
<div><strong>buffer是即将要被写入磁盘的，而cache是被从磁盘中读出来的</strong></div>
<div>&nbsp;</div>
<div>
<ul><li><p>buffer是由各种进程分配的，被用在如输入队列等方面。一个简单的例子如某个进程要求有多个字段读入，在所有字段被读入完整之前，进程把先前读入的字段放在buffer中保存</p></li>
<li><p>cache经常被用在磁盘的I/O请求上，如果有多个进程都要访问某个文件，于是该文件便被做成cache以方便下次被访问，这样可提高系统性能</p></li>
<li><p>Buffer Cachebuffer cache，又称bcache，其中文名称为缓冲器高速缓冲存储器，简称缓冲器高缓。另外，buffer cache按照其工作原理，又被称为块高缓</p></li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4k73n9.html">linux5个搜索命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyn1px9.html">JQ  全选设定与设置选中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd5gky8.html">ActiveMQ讯息传送机制以及ACK机制详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok55m19.html">UITextField的简单操作和实际应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1l3ox9.html">在重命名SqlServer数据库是&comma;报5030错误的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnmzn8.html">SQL Server自动化运维系列 - 多服务器数据收集和性能监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp5zjq.html">Node&period;js、Ionic、Cordova、AngualrJS安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjr6v8.html">十天学Linux内核之第七天---电源开和关时都发生了什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwmo48.html">python爬去电影天堂恐怖片&plus;游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjv2z8.html">EFCore CodeFirst 连接MySql</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyzy0j9.html">支持向量机SVM&mdash;&mdash;专治线性不可分</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jo2738.html">vm12 安装ubuntu15&period;10详细图文教程 虚拟机安装ubuntu安装 ubuntu更新软件 ubuntu一直卡在下载语言怎么办&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k712q.html">json字符串、json对象、数组之间的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wwv4q.html">SoapUI&amp;&num;160&semi;访问代理设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xo70q.html">Sysbench-OLTP数据库测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyrvzq.html">P2731 骑马修栅栏  欧拉函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r2ddz8.html">第三个Sprint冲刺第6天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvxn0x8.html">pyqt 不规则形状窗口显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m23wkrq.html">float double 如何存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5mv39.html">Jboss7&period;1 local EJB lookup problem</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gkxe87.html">PHP安装mysql&period;so扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k4y59j.html">【CSS3动画】transform对文字及图片的旋转、缩放、倾斜和移动</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvp1jqx.html">linux poll函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m4228k.html">初步认识Node 之Node为何物</a>
			</li>
						<li><a href="https://www.batexi.com/a/39037n9d.html">解决iframe作为子窗口，刷新后iframe页面跳转到其它页面的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p4r49x.html">透过HT for Web 3D看动画Easing函数本质</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx3pjqy.html">MyCat源码分析系列之&mdash;&mdash;SQL下发</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7r3x8e.html">TypeScript 强类型 JavaScript &ndash; Rafy Web 框架选型</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96vov84.html">ThreadPool&period;QueueUserWorkItem的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8enoz81.html">Android ORM -- Litepal&lpar;1&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
